!c Description:
!c   ޷׻ץ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-03-31    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved

program obrmap
  use gtool_history
  use prm_common, only: obrinit, struct, property, emol_ini, smax, emax, &
       temp_map_ini, temp_map_end, pres_map_ini, pres_map_end, MapFile
  use interface_mingibbs
  use interface_entropy
  
  implicit none
  real(8)                :: temp_low
  real(8)                :: temp_high
  real(8)                :: pres_low 
  real(8)                :: pres_high
  real(8)                :: dt, dp
  real(8)                :: temp
  real(8)                :: pres
  real(8)                :: entr
  real(8), allocatable   :: mol(:)
  real, allocatable      :: entr_map(:,:)
  real, allocatable      :: mol_map(:,:,:)
  real, allocatable      :: pres_map(:)
  real, allocatable      :: temp_map(:)
  real, allocatable      :: spc(:)
  integer                :: k, l
  integer, parameter     :: M = 100
  integer                :: N
  
!!!
!!!
!!!
  call obrinit

  temp_low = temp_map_ini;   temp_high = temp_map_end
  pres_low = pres_map_ini;   pres_high = pres_map_end
  N = smax
  allocate(mol_map(M, M, N), entr_map(M, M), &
       & temp_map(M), pres_map(M), spc(N), mol(N))
  spc = (/(l, l = 1, N)/)


!!!
!!!֥κǾ
!!!
  dt = (temp_high - temp_low) / (M - 1)
  dp = dlog10(pres_high / pres_low) / (M - 1)  
  
  do k = 1, M
     temp = temp_low + (k - 1) * dt
     do l = 1, M
        pres = pres_low * 10.0d0**((l - 1) * dp)
        
        write(*,*) "temp", temp
        write(*,*) "pres", pres
        call mingibbs(temp, pres, emol_ini, struct, property, mol)

        call entropy(temp, pres, mol, property, entr_all=entr)        
        
        mol_map(k, l, :)  = real(mol, 4)
        entr_map(k, l)  = real(entr, 4)
        pres_map(l) = real(pres, 4)
     end do

     temp_map(k) = real(temp, 4)
  end do
  
  
!!!
!!!NetCDF եν
!!!  
  !°, ɸ
  call HistoryCreate( &                                  ! ҥȥ꡼
       file = MapFile, title='equilibrium caluculation model', &
       source='oboro', &
       institution='GFD_Dennou Club oboro project',     &
       dims=(/'temp','pres','spc '/), dimsizes=(/M,M,N/),      &
       longnames=(/'temperature','pressure   ','species    '/),&
       units=(/'K ','Pa','1 '/),                           &
       origin=0.0, interval=real(pres_low, 4) )
  
  !ν񤭽Ф
  call HistoryPut('pres', pres_map)
  call HistoryPut('temp', temp_map)
  call HistoryPut('spc', spc)
  
  !ͤν
  call HistoryAddVariable( &
       & varname="mol", &
       & dims=(/'temp', 'pres', 'spc '/), &
       & longname="Mol", &
       & units='mol', &
       & xtype="double" )
  
  call HistoryAddVariable( &
       & varname="entr", &
       & dims=(/'temp', 'pres'/), &
       & longname="Entropy", &
       & units='J /K mol', &
       & xtype="double" )
  
  call HistoryPut('mol', mol_map)
  call HistoryPut('entr', entr_map)
  
end program obrmap
