!c Description:
!c   ˰¾å뤿Υץ
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Histry: 
!c   Version    Date          Comment
!c   -------    ----------    --------
!c   1.0        2003-06-01    
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2003, All rights reserved


program obrsvap
  use netcdf
  use prm_common, only: property, obrinit
  use interface_svap_amp
  use interface_svap_antoine
  use interface_name2num

  implicit none
  character(40)               :: FileName     !ե̾
  character(40)               :: LongName     !long_name °
  character(40)               :: UnitsName    !units °
  character(40), allocatable  :: DimLongName(:)
  character(40), allocatable  :: DimUnitsName(:)
  real, allocatable           :: mol(:,:) 
  real, allocatable           :: molfr(:,:) 
  real, allocatable           :: svap(:,:) 
  real, allocatable           :: vap(:,:) 
  real, allocatable           :: temp(:) 
  real, allocatable           :: DimVar1(:) 
  real, allocatable           :: DimVar2(:) 
  real                        :: temp1
  real(8)                     :: svap1
  integer                     :: s1, s2
  integer                     :: x_num
  integer                     :: y_num
  integer                     :: iws
  integer                     :: ncid
  integer                     :: nvar
  integer                     :: natt
  integer                     :: status
  integer                     :: num 
  integer                     :: num1 
  integer                     :: num2 
  integer                     :: num3
  integer                     :: ndim 
  integer                     :: varids(nf90_max_var_dims)
  integer                     :: i, k, l, l1, l2, s
  integer                     :: dimids(nf90_max_var_dims, nf90_max_var_dims) 
  integer                     :: dimlongs(nf90_max_var_dims)
  integer, allocatable        :: ndims(:) 
  character(40)               :: varnames(nf90_max_var_dims) 
  character(40)               :: gasname

  
!!!
!!!ǡƤӽФ
!!!
  call  obrinit

!!!
!!!ե뤫ǡ
!!!  
  write(*,*) "============================================"
  write(*,*) "======NetCDF եꤷƲ======="
  write(*,*) "============================================"
!  read(*,*) FileName
  FileName = "obradbt.nc"
  
  !եΥץ
  status = nf90_open(FileName, nf90_nowrite, ncid)
  if(status /= nf90_noerr) call handle_err(status)
  
  !ξ
  status = nf90_Inquire(ncid, ndim, nvar, natt)
  if(status /= nf90_noerr) call handle_err(status)

  allocate(ndims(nvar))

  !ѿξμ
  do i = 1, nvar
     varids(i) = i
     status = NF90_Inquire_Variable(ncid, varids(i), &
          & name=varnames(i), dimids=dimids(:,i), ndims=ndims(i))
     if(status /= nf90_noerr) call handle_err(status)
  end do
  
  !, ٤ ID 
  do i = 1, nvar
     if (varnames(i) == 'mol') num1 = varids(i)
     if (varnames(i) == 'temp') num2 = varids(i)
     if (varnames(i) == 'molfr') num3 = varids(i)
  end do

  !ǿ
  do i = 1, ndims(num1)
     status = nf90_Inquire_Dimension(ncid, dimids(i, num1), len = dimlongs(i))
     if(status /= nf90_noerr) call handle_err(status)
  end do

  allocate(mol(dimlongs(1), dimlongs(2)), &
       & molfr(dimlongs(1), dimlongs(2)), &
       & vap(dimlongs(1), dimlongs(2)), &
       & svap(dimlongs(1), dimlongs(2)), &
       & temp(dimlongs(2)), &
       & DimVar1(dimlongs(1)), &
       & DimVar2(dimlongs(2)), &
       & DimLongName(2), &
       & DimUnitsName(2))
  
  !ѿͤ
  status = nf90_get_var(ncid, varids(num1), mol)
  if(status /= nf90_noerr) call handle_err(status)

  !ѿͤ
  status = nf90_get_var(ncid, varids(num2), temp)
  if(status /= nf90_noerr) call handle_err(status)
  
  !ѿͤ
  status = nf90_get_var(ncid, varids(num3), molfr)
  if(status /= nf90_noerr) call handle_err(status)
  
  !ͤ
  status = nf90_get_var(ncid, dimids(1, num1), DimVar1)
  if(status /= nf90_noerr) call handle_err(status)
  
  !ͤ
  status = nf90_get_var(ncid, dimids(2, num1), DimVar2)
  if(status /= nf90_noerr) call handle_err(status)
  
  x_num = dimlongs(1)
  y_num = dimlongs(2)


!!!
!!!
!!!
  do s = 1, x_num
     vap(s, :) = molfr(s, :) * DimVar2
  end do


!!!
!!!˰¾
!!!
  do num = 1, y_num
     temp1 = temp(num)
     
     PLOT: do s = 1, x_num
        if (property(s)%method == 3) then 
           call svap_amp(real(temp1, 8), property(s)%svap_cef, svap1)
        elseif (property(s)%method == 4) then 
           call svap_antoine(real(temp1, 8), property(s)%svap_cef, svap1)
        else
           cycle plot
        end if
        
        svap(s,num) = real(svap1, 4) 
     end do PLOT
  end do


!!!
!!!ղ
!!!
  write(*,*) "workstation ID (i) ?"
  call sgpwsn
  read(*,*) iws
  call sglset('LCORNER', .FALSE.)
  call swiset('IWIDTH', 600)
  call swiset('IHEIGHT', 600)
  call gropn(iws)
  call slmgn(0.05, 0.05, 0.01, 0.01)
  
  GRAPH: do s = 1, x_num
     if (property(s)%phase /= 1) cycle GRAPH

     call grfrm
     call uslset('lyinv', .true.)
     call usspnt(y_num, vap(s, :), DimVar2)

     call grstrn(4)
     call uspfit
     call grstrf
     call ussttl('partial pressure', 'Pa', 'Pressure', 'Pa')
     call usdaxs
     
     call sgspli(25)
     call sgplu(y_num, vap(s, :), DimVar2)
!     call uusmkt(3)
!     call uumrk(y_num, vap(s,:), DimVar2)

     l = 35
     plot3: do k = count(property%phase ==1) + 1, x_num
        l1 = len_trim(property(s)%name)
        l2 = len_trim(property(k)%name)
        write(*,*) property(s)%name, property(k)%name

        if (property(s)%name(1:l1-1) /= property(k)%name(1:l2-1)) &
             & cycle plot3

        l = l + 10
        call sgspli(l)
        call sgplu(y_num, svap(k,:), DimVar2)

     end do plot3
     
     call uxsttl('T', trim(property(s)%name), 0.0)
  end do GRAPH


!!!
!!!NH4SH ӽ
!!!  
  GRAPH2: do s = 1, x_num
     if (property(s)%name /= "NH4SH-s") cycle GRAPH2
     gasname = 'NH3-g'
     call name2num(gasname, property%name, s1)
     gasname = 'H2S-g'
     call name2num(gasname, property%name, s2)
     write(*,*) s1, s2

     vap(s,:) = log(molfr(s1, :) * molfr(s2, :) * DimVar2 **2.0D0) &
          & - log(1.0D-2)
     svap(s,:) = 61.781d0 - (10834.0d0 / temp)
     
     call grfrm
     call uslset('lyinv', .true.)
     call usspnt(y_num, vap(s,:), DimVar2)
     call usspnt(y_num, svap(s,:), DimVar2)
     
     call grstrn(1)
     call uspfit
     call grstrf
     call ussttl('equilibrium constant', '1', 'Pressure', 'Pa')
     call usdaxs
     
     call sgspli(25)
     call sgplu(y_num, vap(s, :), DimVar2)
     call sgspli(35)
     call sgplu(y_num, svap(s, :), DimVar2)
     
     call uxsttl('T', trim(property(s)%name), 0.0)
  end do GRAPH2

  
  call grcls

  
  !եΥ
  status = nf90_close(ncid)
  
  
contains

  subroutine handle_err(status)
    integer, intent (in) :: status
    if(status /= nf90_noerr) then
       print *, trim(nf90_strerror(status))
       stop "Stopped"
    end if
  end subroutine handle_err

end program obrsvap

